Package: crochet
Version: 2.3.0
License: MIT + file LICENSE
Title: Implementation Helper for '[' and '[<-' of Custom Matrix-Like
        Types
Description: Functions to help implement the extraction / subsetting / indexing
    function '[' and replacement function '[<-' of custom matrix-like types
    (based on S3, S4, etc.), modeled as closely to the base matrix class as
    possible (with tests to prove it).
Authors@R: person("Alexander", "Grueneberg", email = "cran@agrueneberg.info", role = c("aut", "cre"))
URL: https://github.com/agrueneberg/crochet
BugReports: https://github.com/agrueneberg/crochet/issues
Depends: R (>= 3.0.0)
Imports: methods
Suggests: tinytest, knitr, rmarkdown
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2020-05-19 21:15:31 UTC; agrueneberg
Author: Alexander Grueneberg [aut, cre]
Maintainer: Alexander Grueneberg <cran@agrueneberg.info>
Repository: CRAN
Date/Publication: 2020-05-20 22:40:02 UTC
Built: R 4.6.0; ; 2026-04-25 16:57:19 UTC; unix

# crochet

[![CRAN_Status_Badge](http://www.r-pkg.org/badges/version/crochet)](https://CRAN.R-project.org/package=crochet)
[![Number of direct and total dependencies](https://tinyverse.netlify.com/badge/crochet)](https://tinyverse.netlify.com)
[![Rdoc](http://www.rdocumentation.org/badges/version/crochet)](http://www.rdocumentation.org/packages/crochet)
[![Travis-CI Build Status](https://travis-ci.org/agrueneberg/crochet.svg?branch=master)](https://travis-ci.org/agrueneberg/crochet)
[![AppVeyor Build Status](https://ci.appveyor.com/api/projects/status/5osfclaxqxhq04r2?svg=true)](https://ci.appveyor.com/project/agrueneberg/crochet)
[![Coverage status](https://codecov.io/gh/agrueneberg/crochet/branch/master/graph/badge.svg)](https://codecov.io/github/agrueneberg/crochet?branch=master)

crochet is an R package that provides functions to help implement the extraction / subsetting / indexing function `[` and replacement function `[<-` of custom matrix-like types (based on S3, S4, etc.), modeled as closely to the base `matrix` class as possible (with tests to prove it).


Example
-------

Check out the `Example of a Custom Type that Implements 'extract' and 'replace'` vignette [on the crochet page on CRAN](https://cran.r-project.org/package=crochet).


Installation
------------

Install the stable version from CRAN:

```R
install.packages("crochet")
```

Alternatively, install the development version from GitHub:

```R
# install.packages("remotes")
remotes::install_github("agrueneberg/crochet")
```


Documentation
-------------

Further documentation can be found on [RDocumentation](http://www.rdocumentation.org/packages/crochet).


Contributing
------------

- Issue Tracker: https://github.com/agrueneberg/crochet/issues
- Source Code: https://github.com/agrueneberg/crochet

## -----------------------------------------------------------------------------
dim.StringMatrix <- function(x) {
    attr(x, "_dim") # store dimensions in `_dim` attribute
}

length.StringMatrix <- function(x) {
    prod(dim(x)) # rely on `dim()` method above
}

dimnames.StringMatrix <- function(x) {
    attr(x, "_dimnames") # store dim names in `_dimnames` attribute
}

## ---- eval = FALSE------------------------------------------------------------
#  X[seq(1, 25, by = 5)] # subsetting by positive integers
#  X[1, ] # simplifying subsetting by positive integers
#  X[-(2:5), ] # simplifying subsetting by negative integers
#  X[c(TRUE, FALSE, FALSE, FALSE, FALSE), ] # simplifying subsetting by booleans
#  X["row_1", ] # simplifying subsetting by row names (only if dimnames exist)

## -----------------------------------------------------------------------------
`[.StringMatrix` <- crochet::extract(
    extract_vector = function(x, i, ...) { # i are positive integers
        # Reserve output vector
        subset <- vector(mode = "character", length = length(i))
        # Populate output vector
        for (singleIdx in 1:length(i)) {
            subset[singleIdx] <- substr(attr(x, "_data"), i[singleIdx], i[singleIdx])
        }
        # Return output vector
        return(subset)
    },
    extract_matrix = function(x, i, j, ...) { # i and j are positive integers
        # Reserve output matrix
        subset <- matrix(
            data = vector(mode = "character", length = length(i) * length(j)),
            nrow = length(i),
            ncol = length(j)
        )
        # Populate output matrix
        for (colIdx in 1:length(j)) {
            for (rowIdx in 1:length(i)) {
                # two-dimensional index needs to be converted to one-dimensional index
                singleIdx <- crochet:::ijtok(x, i[rowIdx], j[colIdx])
                subset[rowIdx, colIdx] <- substr(attr(x, "_data"), singleIdx, singleIdx)
            }
        }
        # Return output matrix
        return(subset)
    }
)

## -----------------------------------------------------------------------------
# Generate data
n <- 5
p <- 5
alphabet <- c(0:9, letters)
data <- sample(alphabet, replace = TRUE, size = n * p)

# Create object
obj <- list()
class(obj) <- "StringMatrix"
attr(obj, "_dim") <- c(n, p)
attr(obj, "_dimnames") <- list(paste0("row_", 1:n), paste0("col_", 1:p))
attr(obj, "_data") <- paste(data, collapse = "")

# Call some methods
dim(obj)
nrow(obj) # you get this for free by implementing `dim()`
ncol(obj) # you get this for free by implementing `dim()`
length(obj)
dimnames(obj)
rownames(obj) # you get this for free by implementing `dimnames()`
colnames(obj) # you get this for free by implementing `dimnames()`

# Extract some data
obj[seq(1, length(obj), by = p)] # subsetting by positive integers
obj[1, ] # simplifying subsetting by positive integers
obj[-(2:length(obj)), ] # simplifying subsetting by negative integers
obj[c(TRUE, rep_len(FALSE, nrow(obj) - 1)), ] # simplifying subsetting by booleans
obj["row_1", ] # simplifying subsetting by row names (only if dimnames exist)

## -----------------------------------------------------------------------------
`[.StringMatrix` <- crochet::extract(
    extract_vector = function(x, i, ...) { # i are positive integers
        dotdotdot <- list(...)
        # Reserve output vector
        subset <- vector(mode = "character", length = length(i))
        # Populate output vector
        for (singleIdx in 1:length(i)) {
            subset[singleIdx] <- substr(attr(x, "_data"), i[singleIdx], i[singleIdx])
        }
        # Capitalize output
        if (!is.null(dotdotdot$capitalize) && dotdotdot$capitalize) {
            subset <- toupper(subset)
        }
        # Return output vector
        return(subset)
    },
    extract_matrix = function(x, i, j, ...) { # i and j are positive integers
        dotdotdot <- list(...)
        # Reserve output matrix
        subset <- matrix(
            data = vector(mode = "character", length = length(i) * length(j)),
            nrow = length(i),
            ncol = length(j)
        )
        # Populate output matrix
        for (colIdx in 1:length(j)) {
            for (rowIdx in 1:length(i)) {
                # two-dimensional index needs to be converted to one-dimensional index
                singleIdx <- crochet:::ijtok(x, i[rowIdx], j[colIdx])
                subset[rowIdx, colIdx] <- substr(attr(x, "_data"), singleIdx, singleIdx)
            }
        }
        # Capitalize output
        if (!is.null(dotdotdot$capitalize) && dotdotdot$capitalize) {
            subset <- toupper(subset)
        }
        # Return output matrix
        return(subset)
    }
)

## -----------------------------------------------------------------------------
obj[1, ]
obj[1, , capitalize = TRUE]
obj[1, , capitalize = FALSE]

## -----------------------------------------------------------------------------
`[<-.StringMatrix` <- crochet::replace(
    replace_vector = function(x, i, ..., value) { # i are positive integers
        # Perform replacement
        for (singleIdx in 1:length(i)) {
            substr(attr(x, "_data"), i[singleIdx], i[singleIdx]) <- value[singleIdx]
        }
        # Do not forget to return x
        return(x)
    },
    replace_matrix = function(x, i, j, ..., value) { # i and j are positive integers
        # Convert value to matrix for easier indexing
        dim(value) <- c(length(i), length(j))
        # Perform replacement
        for (colIdx in 1:length(j)) {
            for (rowIdx in 1:length(i)) { # two-dimensional index needs to be converted to one-dimensional index
                singleIdx <- crochet:::ijtok(x, i[rowIdx], j[colIdx])
                substr(attr(x, "_data"), singleIdx, singleIdx) <- value[rowIdx, colIdx]
            }
        }
        # Do not forget to return x
        return(x)
    }
)

## -----------------------------------------------------------------------------
obj[1:7] <- "z"
obj[]

# Define StringMatrix, an example of a custom type that implements extraction
# using the 'extract' function and replacement using the 'replace' function.
# See README for more information on this example type.

registerS3method("length", "StringMatrix", function(x) {
    prod(attr(x, "_dim"))
})

registerS3method("dim", "StringMatrix", function(x) {
    attr(x, "_dim")
})

registerS3method("dimnames", "StringMatrix", function(x) {
    attr(x, "_dimnames")
})

registerS3method("[", "StringMatrix", extract(
    extract_vector = function(x, i, ...) {
        Z <- vector(mode = typeof(attr(x, "_data")), length = length(i))
        # Handle x[FALSE]
        if (length(i) > 0L) {
            for (idx in 1L:length(i)) {
                if (is.na(i[idx])) {
                    # Handle NAs
                    value <- NA_character_
                } else if (i[idx] > nchar(attr(x, "_data"))) {
                    # Handle out of bounds
                    value <- NA_character_
                } else {
                    value <- substr(attr(x, "_data"), i[idx], i[idx])
                }
                Z[idx] <- value
            }
        }
        return(Z)
    },
    extract_matrix = function(x, i, j, ...) {
        Z <- matrix(
            data = vector(mode = typeof(attr(x, "_data")), length = length(i) * length(j)),
            nrow = length(i),
            ncol = length(j),
            dimnames = list(attr(x, "_dimnames")[[1L]][i], attr(x, "_dimnames")[[2L]][j])
        )
        # Handle x[FALSE, ] or x[, FALSE]
        if (length(i) > 0L && length(j) > 0L) {
            for (colIdx in 1L:length(j)) {
                for (rowIdx in 1L:length(i)) {
                    k <- ijtok(x, i[rowIdx], j[colIdx])
                    Z[rowIdx, colIdx] <- substr(attr(x, "_data"), k, k)
                }
            }
        }
        return(Z)
    }
))

registerS3method("[<-", "StringMatrix", replace(
    replace_vector = function(x, i, ..., value) {
        value <- as.character(value)
        # Handle x[FALSE]
        if (length(i) > 0L) {
            for (idx in 1L:length(i)) {
                substr(attr(x, "_data"), i[idx], i[idx])  <- value[idx]
            }
        }
        return(x)
    }, replace_matrix = function(x, i, j, ..., value) {
        value <- as.character(value)
        dim(value) <- c(length(i), length(j))
        # Handle x[FALSE, ] or x[, FALSE]
        if (length(i) > 0L && length(j) > 0L) {
            for (colIdx in 1L:length(j)) {
                for (rowIdx in 1L:length(i)) {
                    k <- ijtok(x, i[rowIdx], j[colIdx])
                    substr(attr(x, "_data"), k, k) <- value[rowIdx, colIdx]
                }
            }
        }
        return(x)
    }
))

# Prepare instances of custom type for testing
seed <- 4711L
n <- 5L
p <- 5L
dimnames <- list(paste0("row_", 1L:n), paste0("col_", 1L:p))
VALUE_POOL <- c(0:9, letters)
OUT_OF_BOUNDS_INT <- 100
OUT_OF_BOUNDS_CHAR <- "x"

generateValues <- function() {
    set.seed(seed)
    sample(VALUE_POOL, replace = TRUE, size = n * p)
}

createStringMatrix <- function() {
    obj <- list()
    class(obj) <- "StringMatrix"
    attr(obj, "_dim") <- c(n, p)
    attr(obj, "_dimnames") <- dimnames
    attr(obj, "_data") <- paste(generateValues(), collapse = "")
    return(obj)
}

createMatrix <- function() {
    matrix(data = generateValues(), nrow = n, ncol = p, dimnames = dimnames)
}

# Source extraction tests
extractionTests <- new.env()
extractionTests$OUT_OF_BOUNDS_INT <- OUT_OF_BOUNDS_INT
extractionTests$OUT_OF_BOUNDS_CHAR <- OUT_OF_BOUNDS_CHAR
extractionTests$COMPARE_OBJECT <- createMatrix()
extractionTests$CUSTOM_OBJECT <- createStringMatrix()
source(
    file = system.file("test-suite", "crochet-extract.R", package = "crochet"),
    local = extractionTests
)

# Source replacement tests
replacementTests <- new.env()
replacementTests$OUT_OF_BOUNDS_INT <- OUT_OF_BOUNDS_INT
replacementTests$OUT_OF_BOUNDS_CHAR <- OUT_OF_BOUNDS_CHAR
replacementTests$VALUE_POOL <- VALUE_POOL
replacementTests$RESET <- function() {
    replacementTests$COMPARE_OBJECT <- createMatrix()
    replacementTests$CUSTOM_OBJECT <- createStringMatrix()
}
replacementTests$RESET()
source(
    file = system.file("test-suite", "crochet-replace.R", package = "crochet"),
    local = replacementTests
)

expect_error(extract())
expect_error(extract(extract_vector = "derp"))
expect_error(extract(extract_matrix = "derp"))
expect_error(extract(extract_vector = "derp", extract_matrix = "derp"))
expect_error(extract(extract_vector = function() {}, extract_matrix = "derp"))
expect_error(extract(extract_vector = "derp", extract_matrix = function() {}))
expect_error(extract(extract_vector = function() {}, extract_matrix = function() {}))
expect_error(extract(extract_vector = function(x) {}, extract_matrix = function(x) {}))
expect_error(extract(extract_vector = function(x, i) {}, extract_matrix = function(x, i) {}))
expect_equal(typeof(extract(extract_vector = function(x, i) {}, extract_matrix = function(x, i, j) {})), "closure")

# This file contains tests (for use with the R packages 'testthat' or
# 'tinytest') to check if a custom type that implements replacement using the
# 'replace' function behaves similarly to a regular R matrix.
#
# To run these tests as part your test suite for your custom type, prepare an
# environment that contains the following names: 'CUSTOM_OBJECT' (an instance
# of your custom type that implements replacement using the 'replace' function
# containing dummy data with at least 3 rows and 3 columns), 'COMPARE_OBJECT'
# (a regular matrix that represents the same dummy data as your object),
# 'OUT_OF_BOUNDS_INT' (an integer that represents an out of bounds value for
# your object in integer indexing), 'OUT_OF_BOUNDS_CHAR' (a string that
# represents an out of bounds value for your object in character indexing),
# 'VALUE_POOL' (a vector containing possible values that your custom type can
# take on), and 'RESET' (a function that resets 'CUSTOM_OBJECT' and
# 'COMPARE_OBJECT' to their original state). Once the environment is prepared,
# the tests can be sourced using 'source(system.file("test-suite",
# "crochet-replace.R", package = "crochet"), local = env)' where 'env' is the
# environment.
#
# See inst/tinytest/test-stringmatrix.R, the BEDMatrix package, or the
# LinkedMatrix package for examples.

# Environment needs to be passed via 'local' argument of 'source'
if (!exists("CROCHET_REPLACE_ENV", inherits = FALSE)) {

# dims are the same
expect_equal(dim(CUSTOM_OBJECT), dim(COMPARE_OBJECT))

# dimnames are the same
expect_equal(dimnames(CUSTOM_OBJECT), dimnames(COMPARE_OBJECT))

# minimum dimension requirement are met
expect_true(nrow(CUSTOM_OBJECT) > 3)
expect_true(ncol(CUSTOM_OBJECT) > 3)
expect_true(length(CUSTOM_OBJECT) > 3)

# maximum dimension requirement are met
expect_true(nrow(CUSTOM_OBJECT) < OUT_OF_BOUNDS_INT)
expect_true(ncol(CUSTOM_OBJECT) < OUT_OF_BOUNDS_INT)
expect_true(length(CUSTOM_OBJECT) < OUT_OF_BOUNDS_INT)

# both matrices are the same
expect_equal(CUSTOM_OBJECT[], COMPARE_OBJECT[])

test_replacement <- function(..., value) {
    CUSTOM_OBJECT[...] <- value
    COMPARE_OBJECT[...] <- value
    expect_equal(CUSTOM_OBJECT[], COMPARE_OBJECT[], info = paste0("INFO: ", deparse(match.call())))
    RESET()
}

test_replacement_warning <- function(..., value) {
    expect_warning(CUSTOM_OBJECT[...] <- value, info = paste0("INFO: ", deparse(match.call())))
    expect_warning(COMPARE_OBJECT[...] <- value, info = paste0("INFO: ", deparse(match.call())))
    expect_equal(CUSTOM_OBJECT[], COMPARE_OBJECT[], info = paste0("INFO: ", deparse(match.call())))
    RESET()
}

test_replacement_error <- function(..., value) {
    expect_error(CUSTOM_OBJECT[...] <- value, info = paste0("INFO: ", deparse(match.call())))
    expect_error(COMPARE_OBJECT[...] <- value, info = paste0("INFO: ", deparse(match.call())))
    RESET()
}

test_replacement_not_implemented <- function(..., value) {
    expect_error(CUSTOM_OBJECT[...] <- value, "not implemented", info = paste0("INFO: ", deparse(match.call())))
    RESET()
}

length <- length(CUSTOM_OBJECT)
values <- VALUE_POOL
value <- values[1]

# single replacement by nothing
test_replacement_error(value = values[0])

# single replacement by positive integers
test_replacement(1, value = value)
test_replacement(c(1, 2), value = value)
test_replacement(c(2, 1), value = value)
test_replacement(1.1, value = value)
test_replacement(c(1.1, 2.1), value = value)
test_replacement(c(2.1, 1.1), value = value)
test_replacement(1.9, value = value)
test_replacement(c(1.9, 2.9), value = value)
test_replacement(c(2.9, 1.9), value = value)
m <- matrix(data = c(1, 1, 2, 2), ncol = 2, byrow = TRUE)
test_replacement(m, value = value)
m <- matrix(data = c(1, 1, 2, 2), ncol = 2, byrow = TRUE)
test_replacement(m, value = value)
m <- matrix(data = c(2, 2, 1, 1), ncol = 2, byrow = TRUE)
test_replacement(m, value = value)
m <- matrix(data = c(1.1, 1.1, 2.1, 2.1), ncol = 2, byrow = TRUE)
test_replacement(m, value = value)
m <- matrix(data = c(2.1, 2.1, 1.1, 1.1), ncol = 2, byrow = TRUE)
test_replacement(m, value = value)
m <- matrix(data = c(1.9, 1.9, 2.9, 2.9), ncol = 2, byrow = TRUE)
test_replacement(m, value = value)
m <- matrix(data = c(2.9, 2.9, 1.9, 1.9), ncol = 2, byrow = TRUE)
test_replacement(m, value = value)
test_replacement(c(1, NA), value = value)

# single replacement by negative integers
test_replacement(-1, value = value)
test_replacement(c(-1, -2), value = value)
test_replacement(c(-2, -1), value = value)
test_replacement(-1.1, value = value)
test_replacement(c(-1.1, -2.1), value = value)
test_replacement(c(-2.1, -1.1), value = value)
test_replacement(-1.9, value = value)
test_replacement(c(-1.9, -2.9), value = value)
test_replacement(c(-2.9, -1.9), value = value)
test_replacement_error(c(-1, NA), value = value)

# single replacement by logicals
test_replacement(TRUE, value = value)
test_replacement(FALSE, value = value)
test_replacement(c(TRUE, FALSE), value = value)
test_replacement(c(FALSE, TRUE), value = value)
m <- matrix(data = rnorm(length), nrow = nrow(CUSTOM_OBJECT), ncol = ncol(CUSTOM_OBJECT))
test_replacement(m > 1, value = value)
test_replacement(c(TRUE, NA), value = value)
test_replacement(c(FALSE, NA), value = value)

# single replacement by characters
if (is.null(dimnames(CUSTOM_OBJECT))) {
    message("skipping character replacement because dimnames are NULL")
} else {
    ROW_NAME_1 <- rownames(CUSTOM_OBJECT)[1]
    ROW_NAME_2 <- rownames(CUSTOM_OBJECT)[2]
    COL_NAME_1 <- colnames(CUSTOM_OBJECT)[1]
    COL_NAME_2 <- colnames(CUSTOM_OBJECT)[2]
    m <- matrix(data = c(ROW_NAME_1, COL_NAME_1, ROW_NAME_2, COL_NAME_2), ncol = 2, byrow = TRUE)
    test_replacement(m, value = value)
    m <- matrix(data = c(ROW_NAME_2, COL_NAME_2, ROW_NAME_1, COL_NAME_1), ncol = 2, byrow = TRUE)
    test_replacement(m, value = value)
}

# single replacement by NA
test_replacement(NA, value = value)
test_replacement(NA_integer_, value = value)
#test_replacement_not_implemented(NA_character_, value = value) # expansion behavior (tricky to implement)

# single replacement by zero
test_replacement_not_implemented(0, value = value)
test_replacement(c(0, 1), value = value)
test_replacement(c(0, -1), value = value)
test_replacement_error(c(0, 1, -1), value = value)

# single out-of-bounds replacements
if (exists("SKIP_OUT_OF_BOUNDS_TESTS", inherits = FALSE) && SKIP_OUT_OF_BOUNDS_TESTS) {
    message("skipping out-of-bounds tests because tests were explicitly disabled")
} else {
    # positive integers
    test_replacement_not_implemented(OUT_OF_BOUNDS_INT, value = value) # expansion behavior
    test_replacement_not_implemented(c(OUT_OF_BOUNDS_INT, 2), value = value) # expansion behavior
    test_replacement_not_implemented(c(2, OUT_OF_BOUNDS_INT), value = value) # expansion behavior
    m <- matrix(data = c(OUT_OF_BOUNDS_INT, OUT_OF_BOUNDS_INT), ncol = 2, byrow = TRUE)
    test_replacement_error(m, value = value)
    # negative integers
    test_replacement(-OUT_OF_BOUNDS_INT, value = value)
    test_replacement(c(-OUT_OF_BOUNDS_INT, -2), value = value)
    test_replacement(c(-2, -OUT_OF_BOUNDS_INT), value = value)
    # logicals
    #test_replacement_not_implemented(rep_len(TRUE, OUT_OF_BOUNDS_INT), value = value) # expansion behavior (tricky to implement)
    #test_replacement_not_implemented(rep_len(FALSE, OUT_OF_BOUNDS_INT), value = value) # expansion behavior (tricky to implement)
    #test_replacement_not_implemented(rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT), value = value) # expansion behavior (tricky to implement)
    #test_replacement_not_implemented(rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT), value = value) # expansion behavior (tricky to implement)
    # characters
    m <- matrix(data = c(OUT_OF_BOUNDS_CHAR, OUT_OF_BOUNDS_CHAR), ncol = 2, byrow = TRUE)
    test_replacement_error(m, value = value)
}

# multi replacement by nothing
test_replacement(, , value = value)

# multi replacement by positive integers
test_replacement(1, , value = value)
test_replacement(, 1, value = value)
test_replacement(1, 1, value = value)
test_replacement(c(1, 2), , value = value)
test_replacement(, c(1, 2), value = value)
test_replacement(c(1, 2), c(1, 2), value = value)
test_replacement(c(2, 1), , value = value)
test_replacement(, c(2, 1), value = value)
test_replacement(c(2, 1), c(2, 1), value = value)
test_replacement(1.1, , value = value)
test_replacement(, 1.1, value = value)
test_replacement(1.1, 1.1, value = value)
test_replacement(c(1.1, 2.1), , value = value)
test_replacement(, c(1.1, 2.1), value = value)
test_replacement(c(1.1, 2.1), c(1.1, 2.1), value = value)
test_replacement(c(2.1, 1.1), , value = value)
test_replacement(, c(2.1, 1.1), value = value)
test_replacement(c(2.1, 1.1), c(2.1, 1.1), value = value)
test_replacement(1.9, , value = value)
test_replacement(, 1.9, value = value)
test_replacement(1.9, 1.9, value = value)
test_replacement(c(1.9, 2.9), , value = value)
test_replacement(, c(1.9, 2.9), value = value)
test_replacement(c(1.9, 2.9), c(1.9, 2.9), value = value)
test_replacement(c(2.9, 1.9), , value = value)
test_replacement(, c(2.9, 1.9), value = value)
test_replacement(c(2.9, 1.9), c(2.9, 1.9), value = value)
test_replacement(c(1, NA), , value = value)
test_replacement(, c(1, NA), value = value)
test_replacement(c(1, NA), c(1, NA), value = value)

# multi replacement by negative integers
test_replacement(c(-1), , value = value)
test_replacement(, c(-1), value = value)
test_replacement(c(-1), c(-1), value = value)
test_replacement(c(-1, -2), , value = value)
test_replacement(, c(-1, -2), value = value)
test_replacement(c(-1, -2), c(-1, -2), value = value)
test_replacement(c(-2, -1), , value = value)
test_replacement(, c(-2, -1), value = value)
test_replacement(c(-2, -1), c(-2, -1), value = value)
test_replacement(c(-1.1), , value = value)
test_replacement(, c(-1.1), value = value)
test_replacement(c(-1.1), c(-1.1), value = value)
test_replacement(c(-1.1, -2.1), , value = value)
test_replacement(, c(-1.1, -2.1), value = value)
test_replacement(c(-1.1, -2.1), c(-1.1, -2.1), value = value)
test_replacement(c(-2.1, -1.1), , value = value)
test_replacement(, c(-2.1, -1.1), value = value)
test_replacement(c(-2.1, -1.1), c(-2.1, -1.1), value = value)
test_replacement(c(-1.9), , value = value)
test_replacement(, c(-1.9), value = value)
test_replacement(c(-1.9), c(-1.9), value = value)
test_replacement(c(-1.9, -2.9), , value = value)
test_replacement(, c(-1.9, -2.9), value = value)
test_replacement(c(-1.9, -2.9), c(-1.9, -2.9), value = value)
test_replacement(c(-2.9, -1.9), , value = value)
test_replacement(, c(-2.9, -1.9), value = value)
test_replacement(c(-2.9, -1.9), c(-2.9, -1.9), value = value)
test_replacement_error(c(-1, NA), , value = value)
test_replacement_error(, c(-1, NA), value = value)
test_replacement_error(c(-1, NA), c(-1, NA), value = value)

# multi replacement by logicals
test_replacement(c(TRUE), , value = value)
test_replacement(, c(TRUE), value = value)
test_replacement(c(TRUE), c(TRUE), value = value)
test_replacement(c(FALSE), , value = value)
test_replacement(, c(FALSE), value = value)
test_replacement(c(FALSE), c(FALSE), value = value)
test_replacement(c(TRUE, FALSE), , value = value)
test_replacement(, c(TRUE, FALSE), value = value)
test_replacement(c(TRUE, FALSE), c(TRUE, FALSE), value = value)
test_replacement(c(FALSE, TRUE), , value = value)
test_replacement(, c(FALSE, TRUE), value = value)
test_replacement(c(FALSE, TRUE), c(FALSE, TRUE), value = value)
test_replacement(c(TRUE, NA), , value = value)
test_replacement(, c(TRUE, NA), value = value)
test_replacement(c(TRUE, NA), c(TRUE, NA), value = value)
test_replacement(c(FALSE, NA), , value = value)
test_replacement(, c(FALSE, NA), value = value)
test_replacement(c(FALSE, NA), c(FALSE, NA), value = value)

# multi replacement by characters
if (is.null(dimnames(CUSTOM_OBJECT))) {
    message("skipping character replacement because dimnames are NULL")
} else {
    ROW_NAME_1 <- rownames(CUSTOM_OBJECT)[1]
    ROW_NAME_2 <- rownames(CUSTOM_OBJECT)[2]
    COL_NAME_1 <- colnames(CUSTOM_OBJECT)[1]
    COL_NAME_2 <- colnames(CUSTOM_OBJECT)[2]
    test_replacement(ROW_NAME_1, , value = value)
    test_replacement(, COL_NAME_1, value = value)
    test_replacement(ROW_NAME_1, COL_NAME_1, value = value)
    test_replacement(c(ROW_NAME_1, ROW_NAME_2), , value = value)
    test_replacement(, c(COL_NAME_1, COL_NAME_2), value = value)
    test_replacement(c(ROW_NAME_1, ROW_NAME_2), c(COL_NAME_1, COL_NAME_2), value = value)
    test_replacement(c(ROW_NAME_2, ROW_NAME_1), , value = value)
    test_replacement(, c(COL_NAME_2, COL_NAME_1), value = value)
    test_replacement(c(ROW_NAME_2, ROW_NAME_1), c(COL_NAME_2, COL_NAME_1), value = value)
    test_replacement_error(c(ROW_NAME_1, NA), , value = value)
    test_replacement_error(, c(COL_NAME_1, NA), value = value)
    test_replacement_error(c(ROW_NAME_1, NA), c(COL_NAME_1, NA), value = value)
}

# multi replacement by NA
test_replacement(NA, , value = value)
test_replacement(, NA, value = value)
test_replacement(NA, NA, value = value)
test_replacement(NA_integer_, , value = value)
test_replacement(, NA_integer_, value = value)
test_replacement(NA_integer_, NA_integer_, value = value)
test_replacement_error(NA_character_, , value = value)
test_replacement_error(, NA_character_, value = value)
test_replacement_error(NA_character_, NA_character_, value = value)

# multi replacement by zero
test_replacement_not_implemented(0, 0, value = value)
test_replacement(c(0, 1), , value = value)
test_replacement(, c(0, 1), value = value)
test_replacement(c(0, 1), c(0, 1), value = value)
test_replacement(c(0, -1), , value = value)
test_replacement(, c(0, -1), value = value)
test_replacement(c(0, -1), c(0, -1), value = value)
test_replacement_error(c(0, 1, -1), , value = value)
test_replacement_error(, c(0, 1, -1), value = value)
test_replacement_error(c(0, 1, -1), c(0, 1, -1), value = value)

# multi out-of-bounds replacements
if (exists("SKIP_OUT_OF_BOUNDS_TESTS", inherits = FALSE) && SKIP_OUT_OF_BOUNDS_TESTS) {
    message("skipping out-of-bounds tests because tests were explicitly disabled")
} else {
    # positive integers
    test_replacement_error(OUT_OF_BOUNDS_INT, , value = value)
    test_replacement_error(, OUT_OF_BOUNDS_INT, value = value)
    test_replacement_error(OUT_OF_BOUNDS_INT, OUT_OF_BOUNDS_INT, value = value)
    test_replacement_error(c(OUT_OF_BOUNDS_INT, 2), , value = value)
    test_replacement_error(, c(OUT_OF_BOUNDS_INT, 2), value = value)
    test_replacement_error(c(OUT_OF_BOUNDS_INT, 2), c(OUT_OF_BOUNDS_INT, 2), value = value)
    test_replacement_error(c(2, OUT_OF_BOUNDS_INT), , value = value)
    test_replacement_error(, c(2, OUT_OF_BOUNDS_INT), value = value)
    test_replacement_error(c(2, OUT_OF_BOUNDS_INT), c(2, OUT_OF_BOUNDS_INT), value = value)
    # negative integers
    test_replacement(c(-OUT_OF_BOUNDS_INT), , value = value)
    test_replacement(, c(-OUT_OF_BOUNDS_INT), value = value)
    test_replacement(c(-OUT_OF_BOUNDS_INT), c(-OUT_OF_BOUNDS_INT), value = value)
    test_replacement(c(-OUT_OF_BOUNDS_INT, -2), , value = value)
    test_replacement(, c(-OUT_OF_BOUNDS_INT, -2), value = value)
    test_replacement(c(-OUT_OF_BOUNDS_INT, -2), c(-OUT_OF_BOUNDS_INT, -2), value = value)
    test_replacement(c(-2, -OUT_OF_BOUNDS_INT), , value = value)
    test_replacement(, c(-2, -OUT_OF_BOUNDS_INT), value = value)
    test_replacement(c(-2, -OUT_OF_BOUNDS_INT), c(-2, -OUT_OF_BOUNDS_INT), value = value)
    # logicals
    test_replacement_error(c(rep_len(TRUE, OUT_OF_BOUNDS_INT)), , value = value)
    test_replacement_error(, c(rep_len(TRUE, OUT_OF_BOUNDS_INT)), value = value)
    test_replacement_error(c(rep_len(TRUE, OUT_OF_BOUNDS_INT)), c(rep_len(TRUE, OUT_OF_BOUNDS_INT)), value = value)
    test_replacement_error(c(rep_len(FALSE, OUT_OF_BOUNDS_INT)), , value = value)
    test_replacement_error(, c(rep_len(FALSE, OUT_OF_BOUNDS_INT)), value = value)
    test_replacement_error(c(rep_len(FALSE, OUT_OF_BOUNDS_INT)), c(rep_len(FALSE, OUT_OF_BOUNDS_INT)), value = value)
    test_replacement_error(rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT), , value = value)
    test_replacement_error(, rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT), value = value)
    test_replacement_error(rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT), rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT), value = value)
    test_replacement_error(rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT), , value = value)
    test_replacement_error(, rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT), value = value)
    test_replacement_error(rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT), rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT), value = value)
    # character
    test_replacement_error(OUT_OF_BOUNDS_CHAR, , value = value)
    test_replacement_error(, OUT_OF_BOUNDS_CHAR, value = value)
    test_replacement_error(OUT_OF_BOUNDS_CHAR, OUT_OF_BOUNDS_CHAR, value = value)
    test_replacement_error(c(ROW_NAME_1, OUT_OF_BOUNDS_CHAR), , value = value)
    test_replacement_error(, c(COL_NAME_1, OUT_OF_BOUNDS_CHAR), value = value)
    test_replacement_error(c(ROW_NAME_1, OUT_OF_BOUNDS_CHAR), c(COL_NAME_1, OUT_OF_BOUNDS_CHAR), value = value)
    test_replacement_error(c(OUT_OF_BOUNDS_CHAR, ROW_NAME_1), , value = value)
    test_replacement_error(, c(OUT_OF_BOUNDS_CHAR, COL_NAME_1), value = value)
    test_replacement_error(c(OUT_OF_BOUNDS_CHAR, ROW_NAME_1), c(OUT_OF_BOUNDS_CHAR, COL_NAME_1), value = value)
}

# n-dimensional replacement causes an error
test_replacement_error(1, 1, 1, value = value)

# value expansion
test_replacement(1, value = values[1])
test_replacement_warning(1, value = values[1:2])
test_replacement_warning(1, value = rep_len(values, length.out = length))
test_replacement_warning(1, value = rep_len(values, length.out = length + 3))
test_replacement(c(1, 2, 3), value = values[1])
test_replacement(c(1, 2, 3), value = values[1:3])
test_replacement_warning(c(1, 2, 3), value = values[1:2])
test_replacement_warning(c(1, 2, 3), value = rep_len(values, length.out = length))
test_replacement_warning(c(1, 2, 3), value = rep_len(values, length.out = length + 3))

}

expect_error(replace())
expect_error(replace(replace_vector = "derp"))
expect_error(replace(replace_matrix = "derp"))
expect_error(replace(replace_vector = "derp", replace_matrix = "derp"))
expect_error(replace(replace_vector = function() {}, replace_matrix = "derp"))
expect_error(replace(replace_vector = "derp", replace_matrix = function() {}))
expect_error(replace(replace_vector = function() {}, replace_matrix = function() {}))
expect_error(replace(replace_vector = function(x) {}, replace_matrix = function(x) {}))
expect_error(replace(replace_vector = function(x, i) {}, replace_matrix = function(x, i) {}))
expect_error(replace(replace_vector = function(x, i, j) {}, replace_matrix = function(x, i, j) {}))
expect_equal(typeof(replace(replace_vector = function(x, i, j, value) {}, replace_matrix = function(x, i, j, value) {})), "closure")
expect_equal(typeof(replace(replace_vector = function(x, i, j, ..., value) {}, replace_matrix = function(x, i, j, ..., value) {})), "closure")

# This file contains tests (for use with the R packages 'testthat' or
# 'tinytest') to check if a custom type that implements extraction using the
# 'extract' function behaves similarly to a regular R matrix.
#
# To run these tests as part your test suite for your custom type, prepare an
# environment that contains the following names: 'CUSTOM_OBJECT' (an instance
# of your custom type that implements extraction using the 'extract' function
# containing dummy data with at least 3 rows and 3 columns), 'COMPARE_OBJECT'
# (a regular matrix that represents the same dummy data as your object),
# 'OUT_OF_BOUNDS_INT' (an integer that represents an out of bounds value for
# your object in integer indexing), 'OUT_OF_BOUNDS_CHAR' (a string that
# represents an out of bounds value for your object in character indexing), and
# optionally 'SKIP_NA_TESTS' (a boolean whether to skip missing value tests or
# not). Once the environment is prepared, the tests can be sourced using
# 'source(system.file("test-suite", "crochet-extract.R", package = "crochet"),
# local = env)' where 'env' is the environment.
#
# See inst/tinytest/test-stringmatrix.R, the BEDMatrix package, or the
# LinkedMatrix package for examples.

# Environment needs to be passed via 'local' argument of 'source'.
if (!exists("CROCHET_EXTRACT_ENV", inherits = FALSE)) {

# lengths are the same
expect_equal(length(CUSTOM_OBJECT), length(COMPARE_OBJECT))

# dims are the same
expect_equal(dim(CUSTOM_OBJECT), dim(COMPARE_OBJECT))

# dimnames are the same
expect_equal(dimnames(CUSTOM_OBJECT), dimnames(COMPARE_OBJECT))

# minimum dimension requirement are met
expect_true(nrow(CUSTOM_OBJECT) > 3)
expect_true(ncol(CUSTOM_OBJECT) > 3)
expect_true(length(CUSTOM_OBJECT) > 3)

# maximum dimension requirement are met
expect_true(nrow(CUSTOM_OBJECT) < OUT_OF_BOUNDS_INT)
expect_true(ncol(CUSTOM_OBJECT) < OUT_OF_BOUNDS_INT)
expect_true(length(CUSTOM_OBJECT) < OUT_OF_BOUNDS_INT)

test_subsetting <- function(...) {

    # Check default drop behavior
    expect_equal(
        CUSTOM_OBJECT[...],
        COMPARE_OBJECT[...],
        info = paste0("INFO: ", deparse(match.call()))
    )

    # Check explicit drop = TRUE
    expect_equal(
        CUSTOM_OBJECT[..., drop = TRUE],
        COMPARE_OBJECT[..., drop = TRUE],
        info = paste0("INFO: ", deparse(match.call()), " (with drop = TRUE)")
    )

    # Check explicit drop = FALSE
    expect_equal(
        CUSTOM_OBJECT[..., drop = FALSE],
        COMPARE_OBJECT[..., drop = FALSE],
        info = paste0("INFO: ", deparse(match.call()), " (with drop = FALSE)")
    )

}

test_subsetting_error <- function(...) {

    # Check default drop behavior
    expect_error(
        CUSTOM_OBJECT[...],
        info = paste0("INFO: ", deparse(match.call()))
    )
    expect_error(
        COMPARE_OBJECT[...],
        info = paste0("INFO: ", deparse(match.call()))
    )

    # Check explicit drop = TRUE
    expect_error(
        CUSTOM_OBJECT[..., drop = TRUE],
        info = paste0("INFO: ", deparse(match.call()), " (with drop = TRUE)")
    )
    expect_error(
        COMPARE_OBJECT[..., drop = TRUE],
        info = paste0("INFO: ", deparse(match.call()), " (with drop = TRUE)")
    )

    # Check explicit drop = FALSE
    expect_error(
        CUSTOM_OBJECT[..., drop = FALSE],
        info = paste0("INFO: ", deparse(match.call()), " (with drop = FALSE)")
    )
    expect_error(
        COMPARE_OBJECT[..., drop = FALSE],
        info = paste0("INFO: ", deparse(match.call()), " (with drop = FALSE)")
    )

}

# single indexing by nothing
test_subsetting()

# single indexing by positive integers
test_subsetting(1)
test_subsetting(c(1, 2))
test_subsetting(c(2, 1))
test_subsetting(1.1)
test_subsetting(c(1.1, 2.1))
test_subsetting(c(2.1, 1.1))
test_subsetting(1.9)
test_subsetting(c(1.9, 2.9))
test_subsetting(c(2.9, 1.9))
test_subsetting(OUT_OF_BOUNDS_INT)
test_subsetting(c(OUT_OF_BOUNDS_INT, 2))
test_subsetting(c(2, OUT_OF_BOUNDS_INT))
m <- matrix(data = c(1, 1, 2, 2), ncol = 2, byrow = TRUE)
test_subsetting(m)
m <- matrix(data = c(1, 1, 2, 2), ncol = 2, byrow = TRUE)
test_subsetting(m)
m <- matrix(data = c(2, 2, 1, 1), ncol = 2, byrow = TRUE)
test_subsetting(m)
m <- matrix(data = c(1.1, 1.1, 2.1, 2.1), ncol = 2, byrow = TRUE)
test_subsetting(m)
m <- matrix(data = c(2.1, 2.1, 1.1, 1.1), ncol = 2, byrow = TRUE)
test_subsetting(m)
m <- matrix(data = c(1.9, 1.9, 2.9, 2.9), ncol = 2, byrow = TRUE)
test_subsetting(m)
m <- matrix(data = c(2.9, 2.9, 1.9, 1.9), ncol = 2, byrow = TRUE)
test_subsetting(m)
m <- matrix(data = c(OUT_OF_BOUNDS_INT, OUT_OF_BOUNDS_INT), ncol = 2, byrow = TRUE)
test_subsetting_error(m)

# single indexing by negative integers
test_subsetting(-1)
test_subsetting(c(-1, -2))
test_subsetting(c(-2, -1))
test_subsetting(-1.1)
test_subsetting(c(-1.1, -2.1))
test_subsetting(c(-2.1, -1.1))
test_subsetting(-1.9)
test_subsetting(c(-1.9, -2.9))
test_subsetting(c(-2.9, -1.9))
test_subsetting(-OUT_OF_BOUNDS_INT)
test_subsetting(c(-OUT_OF_BOUNDS_INT, -2))
test_subsetting(c(-2, -OUT_OF_BOUNDS_INT))

# single indexing by logicals
test_subsetting(TRUE)
test_subsetting(FALSE)
test_subsetting(c(TRUE, FALSE))
test_subsetting(c(FALSE, TRUE))
test_subsetting(rep_len(TRUE, OUT_OF_BOUNDS_INT))
test_subsetting(rep_len(FALSE, OUT_OF_BOUNDS_INT))
test_subsetting(rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT))
test_subsetting(rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT))
m <- matrix(data = rnorm(length(CUSTOM_OBJECT)), nrow = nrow(CUSTOM_OBJECT), ncol = ncol(CUSTOM_OBJECT))
test_subsetting(m > 1)

# single indexing by characters
if (is.null(dimnames(CUSTOM_OBJECT))) {
    message("skipping character indexing because dimnames are NULL")
} else {
    ROW_NAME_1 <- rownames(CUSTOM_OBJECT)[1]
    ROW_NAME_2 <- rownames(CUSTOM_OBJECT)[2]
    COL_NAME_1 <- colnames(CUSTOM_OBJECT)[1]
    COL_NAME_2 <- colnames(CUSTOM_OBJECT)[2]
    test_subsetting(ROW_NAME_1)
    test_subsetting(OUT_OF_BOUNDS_CHAR)
    m <- matrix(data = c(ROW_NAME_1, COL_NAME_1, ROW_NAME_2, COL_NAME_2), ncol = 2, byrow = TRUE)
    test_subsetting(m)
    m <- matrix(data = c(ROW_NAME_2, COL_NAME_2, ROW_NAME_1, COL_NAME_1), ncol = 2, byrow = TRUE)
    test_subsetting(m)
    m <- matrix(data = c(OUT_OF_BOUNDS_CHAR, OUT_OF_BOUNDS_CHAR), ncol = 2, byrow = TRUE)
    test_subsetting_error(m)
}

# single indexing by NA
if (exists("SKIP_NA_TESTS", inherits = FALSE) && SKIP_NA_TESTS) {
    message("skipping NA tests because tests were explicitly disabled")
} else {
    ROW_NAME_1 <- rownames(CUSTOM_OBJECT)[1]
    test_subsetting(NA)
    test_subsetting(NA_integer_)
    test_subsetting(NA_character_)
    test_subsetting(c(1, NA))
    test_subsetting_error(c(-1, NA))
    test_subsetting(c(TRUE, NA))
    test_subsetting(c(FALSE, NA))
    test_subsetting(c(ROW_NAME_1, NA))
}

# single indexing by zero
# test_subsetting_error(0) # Not implemented
test_subsetting(c(0, 1))
test_subsetting(c(0, -1))
test_subsetting_error(c(0, 1, -1))

# multi indexing by nothing
test_subsetting(, )

# multi indexing by positive integers
test_subsetting(1, )
test_subsetting(, 1)
test_subsetting(1, 1)
test_subsetting(c(1, 2), )
test_subsetting(, c(1, 2))
test_subsetting(c(1, 2), c(1, 2))
test_subsetting(c(2, 1), )
test_subsetting(, c(2, 1))
test_subsetting(c(2, 1), c(2, 1))
test_subsetting(1.1, )
test_subsetting(, 1.1)
test_subsetting(1.1, 1.1)
test_subsetting(c(1.1, 2.1), )
test_subsetting(, c(1.1, 2.1))
test_subsetting(c(1.1, 2.1), c(1.1, 2.1))
test_subsetting(c(2.1, 1.1), )
test_subsetting(, c(2.1, 1.1))
test_subsetting(c(2.1, 1.1), c(2.1, 1.1))
test_subsetting(1.9, )
test_subsetting(, 1.9)
test_subsetting(1.9, 1.9)
test_subsetting(c(1.9, 2.9), )
test_subsetting(, c(1.9, 2.9))
test_subsetting(c(1.9, 2.9), c(1.9, 2.9))
test_subsetting(c(2.9, 1.9), )
test_subsetting(, c(2.9, 1.9))
test_subsetting(c(2.9, 1.9), c(2.9, 1.9))
test_subsetting_error(OUT_OF_BOUNDS_INT, )
test_subsetting_error(, OUT_OF_BOUNDS_INT)
test_subsetting_error(OUT_OF_BOUNDS_INT, OUT_OF_BOUNDS_INT)
test_subsetting_error(c(OUT_OF_BOUNDS_INT, 2), )
test_subsetting_error(, c(OUT_OF_BOUNDS_INT, 2))
test_subsetting_error(c(OUT_OF_BOUNDS_INT, 2), c(OUT_OF_BOUNDS_INT, 2))
test_subsetting_error(c(2, OUT_OF_BOUNDS_INT), )
test_subsetting_error(, c(2, OUT_OF_BOUNDS_INT))
test_subsetting_error(c(2, OUT_OF_BOUNDS_INT), c(2, OUT_OF_BOUNDS_INT))

# multi indexing by negative integers
test_subsetting(c(-1), )
test_subsetting(, c(-1))
test_subsetting(c(-1), c(-1))
test_subsetting(c(-1, -2), )
test_subsetting(, c(-1, -2))
test_subsetting(c(-1, -2), c(-1, -2))
test_subsetting(c(-2, -1), )
test_subsetting(, c(-2, -1))
test_subsetting(c(-2, -1), c(-2, -1))
test_subsetting(c(-1.1), )
test_subsetting(, c(-1.1))
test_subsetting(c(-1.1), c(-1.1))
test_subsetting(c(-1.1, -2.1), )
test_subsetting(, c(-1.1, -2.1))
test_subsetting(c(-1.1, -2.1), c(-1.1, -2.1))
test_subsetting(c(-2.1, -1.1), )
test_subsetting(, c(-2.1, -1.1))
test_subsetting(c(-2.1, -1.1), c(-2.1, -1.1))
test_subsetting(c(-1.9), )
test_subsetting(, c(-1.9))
test_subsetting(c(-1.9), c(-1.9))
test_subsetting(c(-1.9, -2.9), )
test_subsetting(, c(-1.9, -2.9))
test_subsetting(c(-1.9, -2.9), c(-1.9, -2.9))
test_subsetting(c(-2.9, -1.9), )
test_subsetting(, c(-2.9, -1.9))
test_subsetting(c(-2.9, -1.9), c(-2.9, -1.9))
test_subsetting(c(-OUT_OF_BOUNDS_INT), )
test_subsetting(, c(-OUT_OF_BOUNDS_INT))
test_subsetting(c(-OUT_OF_BOUNDS_INT), c(-OUT_OF_BOUNDS_INT))
test_subsetting(c(-OUT_OF_BOUNDS_INT, -2), )
test_subsetting(, c(-OUT_OF_BOUNDS_INT, -2))
test_subsetting(c(-OUT_OF_BOUNDS_INT, -2), c(-OUT_OF_BOUNDS_INT, -2))
test_subsetting(c(-2, -OUT_OF_BOUNDS_INT), )
test_subsetting(, c(-2, -OUT_OF_BOUNDS_INT))
test_subsetting(c(-2, -OUT_OF_BOUNDS_INT), c(-2, -OUT_OF_BOUNDS_INT))

# multi indexing by logicals
test_subsetting(c(TRUE), )
test_subsetting(, c(TRUE))
test_subsetting(c(TRUE), c(TRUE))
test_subsetting_error(c(rep_len(TRUE, OUT_OF_BOUNDS_INT)), )
test_subsetting_error(, c(rep_len(TRUE, OUT_OF_BOUNDS_INT)))
test_subsetting_error(c(rep_len(TRUE, OUT_OF_BOUNDS_INT)), c(rep_len(TRUE, OUT_OF_BOUNDS_INT)))
test_subsetting(c(FALSE), )
test_subsetting(, c(FALSE))
test_subsetting(c(FALSE), c(FALSE))
test_subsetting_error(c(rep_len(FALSE, OUT_OF_BOUNDS_INT)), )
test_subsetting_error(, c(rep_len(FALSE, OUT_OF_BOUNDS_INT)))
test_subsetting_error(c(rep_len(FALSE, OUT_OF_BOUNDS_INT)), c(rep_len(FALSE, OUT_OF_BOUNDS_INT)))
test_subsetting(c(TRUE, FALSE), )
test_subsetting(, c(TRUE, FALSE))
test_subsetting(c(TRUE, FALSE), c(TRUE, FALSE))
test_subsetting_error(rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT), )
test_subsetting_error(, rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT))
test_subsetting_error(rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT), rep_len(c(TRUE, FALSE), OUT_OF_BOUNDS_INT))
test_subsetting(c(FALSE, TRUE), )
test_subsetting(, c(FALSE, TRUE))
test_subsetting(c(FALSE, TRUE), c(FALSE, TRUE))
test_subsetting_error(rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT), )
test_subsetting_error(, rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT))
test_subsetting_error(rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT), rep_len(c(FALSE, TRUE), OUT_OF_BOUNDS_INT))

# multi indexing by characters
if (is.null(dimnames(CUSTOM_OBJECT))) {
    message("skipping character indexing because dimnames are NULL")
} else {
    ROW_NAME_1 <- rownames(CUSTOM_OBJECT)[1]
    ROW_NAME_2 <- rownames(CUSTOM_OBJECT)[2]
    COL_NAME_1 <- colnames(CUSTOM_OBJECT)[1]
    COL_NAME_2 <- colnames(CUSTOM_OBJECT)[2]
    test_subsetting(ROW_NAME_1, )
    test_subsetting(, COL_NAME_1)
    test_subsetting(ROW_NAME_1, COL_NAME_1)
    test_subsetting_error(OUT_OF_BOUNDS_CHAR, )
    test_subsetting_error(, OUT_OF_BOUNDS_CHAR)
    test_subsetting_error(OUT_OF_BOUNDS_CHAR, OUT_OF_BOUNDS_CHAR)
    test_subsetting(c(ROW_NAME_1, ROW_NAME_2), )
    test_subsetting(, c(COL_NAME_1, COL_NAME_2))
    test_subsetting(c(ROW_NAME_1, ROW_NAME_2), c(COL_NAME_1, COL_NAME_2))
    test_subsetting(c(ROW_NAME_2, ROW_NAME_1), )
    test_subsetting(, c(COL_NAME_2, COL_NAME_1))
    test_subsetting(c(ROW_NAME_2, ROW_NAME_1), c(COL_NAME_2, COL_NAME_1))
    test_subsetting_error(c(ROW_NAME_1, OUT_OF_BOUNDS_CHAR), )
    test_subsetting_error(, c(COL_NAME_1, OUT_OF_BOUNDS_CHAR))
    test_subsetting_error(c(ROW_NAME_1, OUT_OF_BOUNDS_CHAR), c(COL_NAME_1, OUT_OF_BOUNDS_CHAR))
    test_subsetting_error(c(OUT_OF_BOUNDS_CHAR, ROW_NAME_1), )
    test_subsetting_error(, c(OUT_OF_BOUNDS_CHAR, COL_NAME_1))
    test_subsetting_error(c(OUT_OF_BOUNDS_CHAR, ROW_NAME_1), c(OUT_OF_BOUNDS_CHAR, COL_NAME_1))
}

# multi indexing by NA
if (exists("SKIP_NA_TESTS", inherits = FALSE) && SKIP_NA_TESTS) {
    message("skipping NA tests because tests were explicitly disabled")
} else {
    ROW_NAME_1 <- rownames(CUSTOM_OBJECT)[1]
    COL_NAME_1 <- colnames(CUSTOM_OBJECT)[1]
    test_subsetting(NA, )
    test_subsetting(, NA)
    test_subsetting(NA, NA)
    test_subsetting(NA_integer_, )
    test_subsetting(, NA_integer_)
    test_subsetting(NA_integer_, NA_integer_)
    test_subsetting_error(NA_character_, )
    test_subsetting_error(, NA_character_)
    test_subsetting_error(NA_character_, NA_character_)
    test_subsetting(c(1, NA), )
    test_subsetting(, c(1, NA))
    test_subsetting(c(1, NA), c(1, NA))
    test_subsetting_error(c(-1, NA), )
    test_subsetting_error(, c(-1, NA))
    test_subsetting_error(c(-1, NA), c(-1, NA))
    test_subsetting(c(TRUE, NA), )
    test_subsetting(, c(TRUE, NA))
    test_subsetting(c(TRUE, NA), c(TRUE, NA))
    test_subsetting(c(FALSE, NA), )
    test_subsetting(, c(FALSE, NA))
    test_subsetting(c(FALSE, NA), c(FALSE, NA))
    test_subsetting_error(c(ROW_NAME_1, NA), )
    test_subsetting_error(, c(COL_NAME_1, NA))
    test_subsetting_error(c(ROW_NAME_1, NA), c(COL_NAME_1, NA))
}

# multi indexing by zero
# test_subsetting_error(0, 0) # Not implemented
test_subsetting(c(0, 1), )
test_subsetting(, c(0, 1))
test_subsetting(c(0, 1), c(0, 1))
test_subsetting(c(0, -1), )
test_subsetting(, c(0, -1))
test_subsetting(c(0, -1), c(0, -1))
test_subsetting_error(c(0, 1, -1), )
test_subsetting_error(, c(0, 1, -1))
test_subsetting_error(c(0, 1, -1), c(0, 1, -1))

# n-dimensional indexing causes an error
test_subsetting_error(1, 1, 1)

}

Potential Features
------------------

* callLater which runs code in thread pool.
* LoopingCall which runs code in thread pool.
* Notice reactor is already being run by someone else, e.g. Twisted being used
  as WSGI container? or maybe no_setup().
* Poll for dead processes.

---
title: "Example of a Custom Type that Implements 'extract' and 'replace'"
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Example of a custom type that implements 'extract' and 'replace'}
  %\VignetteEncoding{UTF-8}
output: rmarkdown::html_vignette
---

In this example we are going to implement a custom matrix-like type that stores data in form of characters as a string in the `_data` attribute of an object. This is not going to be particularly useful, but serves as an easy to understand starting point that can be adapted for other storage mechanisms, e.g., databases, shared memory, and so on.

First we need to clarify what we mean by matrix-like type: a matrix-like type is a class (i.e., implemented using any of R's object-oriented mechanisms) that implements **at least** the `dim()`, `length()`, `dimnames()`, and the `[` extraction method.

Let's call our type `StringMatrix` and implement it as an S3 class. If you need a refresher on S3 classes, please read the [OO field guide](http://adv-r.had.co.nz/OO-essentials.html) chapter in the **Advanced R** book by Hadley Wickham first. Let's start with implementing the `dim()`, `length()`, and `dimnames()` methods:

```{r}
dim.StringMatrix <- function(x) {
    attr(x, "_dim") # store dimensions in `_dim` attribute
}

length.StringMatrix <- function(x) {
    prod(dim(x)) # rely on `dim()` method above
}

dimnames.StringMatrix <- function(x) {
    attr(x, "_dimnames") # store dim names in `_dimnames` attribute
}
```

Subsetting in R is very powerful and can therefore be difficult to implement depending on how many indexing mechanisms you want to support. For example, given a 5x5 matrix, all of the following cases (non-exhaustive) are equivalent:

```{r, eval = FALSE}
X[seq(1, 25, by = 5)] # subsetting by positive integers
X[1, ] # simplifying subsetting by positive integers
X[-(2:5), ] # simplifying subsetting by negative integers
X[c(TRUE, FALSE, FALSE, FALSE, FALSE), ] # simplifying subsetting by booleans
X["row_1", ] # simplifying subsetting by row names (only if dimnames exist)
```

This complexity motivated the development of the crochet package. The `extract()` function of the package takes care of converting all those indexing mechanisms to positive integers, which is typically the easiest mechanism to implement. `extract()` returns a function that can be used as a method for `[` for a custom type. Matrices can be subsetted using one-dimensional (`i` only) and two-dimensional indices (`i` and `j`) and both have very different behaviors. Therefore, two functions need to be provided to `extract()` as `extract_vector` and `extract_matrix`. `extract_vector` has to be a function of the form `function(x, i, ...)` and `extract_matrix` a function of the form `function(x, i, j, ...)`. Both functions return a subset of `x`.

The following snippets gives a simple way to extract characters from a string one by one. In R, we can extract the *n*th character from a string using the `substr()` function: `substr(x, n, n)`. Conversely, the *n*th character can be replaced as follows: `substr(x, n, n) <- value`. Note that the `[` character is not allowed in a variable name, so it needs to be escaped with backticks when establishing the return value of `extract()` as a method of `StringMatrix`.

```{r}
`[.StringMatrix` <- crochet::extract(
    extract_vector = function(x, i, ...) { # i are positive integers
        # Reserve output vector
        subset <- vector(mode = "character", length = length(i))
        # Populate output vector
        for (singleIdx in 1:length(i)) {
            subset[singleIdx] <- substr(attr(x, "_data"), i[singleIdx], i[singleIdx])
        }
        # Return output vector
        return(subset)
    },
    extract_matrix = function(x, i, j, ...) { # i and j are positive integers
        # Reserve output matrix
        subset <- matrix(
            data = vector(mode = "character", length = length(i) * length(j)),
            nrow = length(i),
            ncol = length(j)
        )
        # Populate output matrix
        for (colIdx in 1:length(j)) {
            for (rowIdx in 1:length(i)) {
                # two-dimensional index needs to be converted to one-dimensional index
                singleIdx <- crochet:::ijtok(x, i[rowIdx], j[colIdx])
                subset[rowIdx, colIdx] <- substr(attr(x, "_data"), singleIdx, singleIdx)
            }
        }
        # Return output matrix
        return(subset)
    }
)
```

We can now create an object of the `StringMatrix` class and provide it with some data:

```{r}
# Generate data
n <- 5
p <- 5
alphabet <- c(0:9, letters)
data <- sample(alphabet, replace = TRUE, size = n * p)

# Create object
obj <- list()
class(obj) <- "StringMatrix"
attr(obj, "_dim") <- c(n, p)
attr(obj, "_dimnames") <- list(paste0("row_", 1:n), paste0("col_", 1:p))
attr(obj, "_data") <- paste(data, collapse = "")

# Call some methods
dim(obj)
nrow(obj) # you get this for free by implementing `dim()`
ncol(obj) # you get this for free by implementing `dim()`
length(obj)
dimnames(obj)
rownames(obj) # you get this for free by implementing `dimnames()`
colnames(obj) # you get this for free by implementing `dimnames()`

# Extract some data
obj[seq(1, length(obj), by = p)] # subsetting by positive integers
obj[1, ] # simplifying subsetting by positive integers
obj[-(2:length(obj)), ] # simplifying subsetting by negative integers
obj[c(TRUE, rep_len(FALSE, nrow(obj) - 1)), ] # simplifying subsetting by booleans
obj["row_1", ] # simplifying subsetting by row names (only if dimnames exist)
```

Different from `[` for atomic vectors (where both named and unnamed arguments are interpreted as indices), optional named arguments can be passed to `extract_vector` and `extact_matrix` as `...`. This can be useful for some optimization strategies (e.g., fadvise or madvise). Let's add an option to capitalize subsets as a demonstration:

```{r}
`[.StringMatrix` <- crochet::extract(
    extract_vector = function(x, i, ...) { # i are positive integers
        dotdotdot <- list(...)
        # Reserve output vector
        subset <- vector(mode = "character", length = length(i))
        # Populate output vector
        for (singleIdx in 1:length(i)) {
            subset[singleIdx] <- substr(attr(x, "_data"), i[singleIdx], i[singleIdx])
        }
        # Capitalize output
        if (!is.null(dotdotdot$capitalize) && dotdotdot$capitalize) {
            subset <- toupper(subset)
        }
        # Return output vector
        return(subset)
    },
    extract_matrix = function(x, i, j, ...) { # i and j are positive integers
        dotdotdot <- list(...)
        # Reserve output matrix
        subset <- matrix(
            data = vector(mode = "character", length = length(i) * length(j)),
            nrow = length(i),
            ncol = length(j)
        )
        # Populate output matrix
        for (colIdx in 1:length(j)) {
            for (rowIdx in 1:length(i)) {
                # two-dimensional index needs to be converted to one-dimensional index
                singleIdx <- crochet:::ijtok(x, i[rowIdx], j[colIdx])
                subset[rowIdx, colIdx] <- substr(attr(x, "_data"), singleIdx, singleIdx)
            }
        }
        # Capitalize output
        if (!is.null(dotdotdot$capitalize) && dotdotdot$capitalize) {
            subset <- toupper(subset)
        }
        # Return output matrix
        return(subset)
    }
)
```

Now we can capitalize the output as follows:

```{r}
obj[1, ]
obj[1, , capitalize = TRUE]
obj[1, , capitalize = FALSE]
```

To support replacement, `replace()` returns a function that can be used as a method for `[<-` for a custom type. Analogous to the `extract()` method, two parameters are required by `replace()`: `replace_vector` has to be a function of the form `function(x, i, ..., value)` and `replace_matrix` a function of the form `function(x, i, j, ..., value)`. Both functions return a likely modified version of `x`.

```{r}
`[<-.StringMatrix` <- crochet::replace(
    replace_vector = function(x, i, ..., value) { # i are positive integers
        # Perform replacement
        for (singleIdx in 1:length(i)) {
            substr(attr(x, "_data"), i[singleIdx], i[singleIdx]) <- value[singleIdx]
        }
        # Do not forget to return x
        return(x)
    },
    replace_matrix = function(x, i, j, ..., value) { # i and j are positive integers
        # Convert value to matrix for easier indexing
        dim(value) <- c(length(i), length(j))
        # Perform replacement
        for (colIdx in 1:length(j)) {
            for (rowIdx in 1:length(i)) { # two-dimensional index needs to be converted to one-dimensional index
                singleIdx <- crochet:::ijtok(x, i[rowIdx], j[colIdx])
                substr(attr(x, "_data"), singleIdx, singleIdx) <- value[rowIdx, colIdx]
            }
        }
        # Do not forget to return x
        return(x)
    }
)
```

Now we can replace some data:

```{r}
obj[1:7] <- "z"
obj[]
```

As you can see the simple extraction and replacement functions above cover a lot of scenarios. There are some edge cases not mentioned here that can't be handled by crochet automatically (e.g., x[FALSE], combinations with `NA`s, and so on), so if you want full coverage, you should run the crochet test suite on your custom type. Examples of this can be found in `inst/tinytest/test-stringmatrix.R` for the `StringMatrix` type, and in the [BEDMatrix](https://cran.r-project.org/package=BEDMatrix) or [LinkedMatrix](https://cran.r-project.org/package=LinkedMatrix) packages.
